POJ3126 Prime Path

来源:互联网 发布:德邦数据分析招聘信息 编辑:程序博客网 时间:2024/06/06 01:27

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670


题意:给定两个无前导零的四位数(素数),每次第一个数4位数字任意改变一位,如1111 可以变为1110,1112,1121,1211,2111等,第一个数经过最少多少次变化可以得到第二个数

思路:通过打表计算出1000-10000之间的所有素数,然后从给定的第一个数起,通过bfs将所有满足条件的素数,直到遇到第二个数

#include<stdio.h>#include<cmath>#include<cstring>#include<string>#include<queue>#include<deque>#include<algorithm>#include<iostream>using namespace std;typedef long long ll;const int N = 10000;int prime[1200], cnt = 0, vis[12000] = {0};int v[1200];struct sk{    int num;    int step;};void creat_prime(){    int m = sqrt(N + 0.5);    for(int i = 2; i <= m; i++)    {        if(!vis[i])        {            for(int j = i * i; j <= N; j += i)                vis[j] = 1;        }    }    for(int i = 1000; i <= N; i++)    {        if(!vis[i]) prime[cnt++] = i;    }}int ck(int a, int b){    int ans = 0, x, y;    for(int i = 0; i < 4; i++)    {        x = a % 10;        y = b % 10;        if(x != y) ans++;        a /= 10;        b /= 10;    }    return ans;}int bfs(int a, int b){    queue<sk> q;    sk a1, b1;    a1.num = a; a1.step = 0;    q.push(a1);    while(!q.empty())    {        b1 = q.front();        q.pop();        if(b1.num == b) return b1.step;        for(int i = 0; i < cnt; i++)        {            if(v[i]) continue;            a1.num = prime[i];            a1.step = b1.step + 1;            int y = ck(b1.num, a1.num);            if(y > 1) continue;            else            {                v[i] = 1;                if(y == 1) q.push(a1);            }        }    }    return -1;}int main(){    int t, m, n;    creat_prime(); //1000 - 9999内的素数    scanf("%d", &t);    while(t--)    {        memset(v, 0, sizeof v);        scanf("%d %d", &m, &n);        int ans = bfs(m, n);        if(ans != -1) printf("%d\n",ans);        else printf("Impossible\n");    }    return 0;}


0 0
原创粉丝点击